/*
 * Base.h
 *
 *  Created on: 4-mag-2009
 *      Author: researcher
 */

#ifndef BASE_H_
#define BASE_H_

class Base {
public:
	Base();
	virtual ~Base();
    int getX() const
    {
        return x;
    }

    void setX(int x)
    {
        this->x = x;
    }

    int getY() const
    {
        return y;
    }

    void setY(int y)
    {
        this->y = y;
    }
    virtual void draw() = 0;
    virtual void resize(float size) = 0;

private:
	int x;
	int y;
};

#endif /* BASE_H_ */
