//============================================================================
// Name        : TestBaseVector.cpp
// Author      :
// Version     :
// Copyright   : Your copyright notice
// Description : Hello World in C++, Ansi-style
//============================================================================

#include "Base.h"
#include "Derived1.h"
#include "Derived2.h"
#include "MultipleBases.h"

#include <vector>
#include <iostream>
using namespace std;

int main() {
	cout << "TestBaseVector" << endl;

	vector<Base*> myVector;

	Derived1* aD1 = new Derived1();
	Derived2* aD2 = new Derived2();
	MultipleBases* aMB = new MultipleBases();

	myVector.push_back(aD1);
	myVector.push_back(aD2);
	myVector.push_back(aMB);

	// see http://www.cplusplus.com/doc/tutorial/typecasting/ for dynamic_cast
	if ( dynamic_cast<Derived1*>(myVector[0]) )
		cout << "Element 0 is a Derived1*" << endl;// should print this
	else if ( dynamic_cast<Derived2*>(myVector[0]) )
		cout << "Element 0 is a Derived2*" << endl;// should NOT print this !

	if ( dynamic_cast<Derived1*>(myVector[1]) )
			cout << "Element 1 is a Derived1*" << endl; // should NOT print this !
	else if ( dynamic_cast<Derived2*>(myVector[1]) )
		cout << "Element 1 is a Derived2*" << endl; // should print this

	if ( dynamic_cast<MultipleBases*>(myVector[2]) )
		cout << "Element 2 is a MultipleBases*" << endl;


	return 0;
}
